pcl::ColorModality< PointInT > Class Template Reference

`#include <pcl/recognition/color_modality.h>`

Inheritance diagram for pcl::ColorModality< PointInT >:

## Classes

struct | Candidate

## Public Types

typedef pcl::PointCloud< PointInT > | PointCloudIn
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| ColorModality ()
virtual | ~ColorModality ()
QuantizedMap & | getQuantizedMap ()
| Returns a reference to the internally computed quantized map. More...
QuantizedMap & | getSpreadedQuantizedMap ()
| Returns a reference to the internally computed spreaded quantized map. More...
void | extractFeatures (const MaskMap &mask, size_t nr_features, size_t modalityIndex, std::vector< QuantizedMultiModFeature > &features) const
| Extracts features from this modality within the specified mask. More...
virtual void | setInputCloud (const typename PointCloudIn::ConstPtr &cloud)
| Provide a pointer to the input dataset (overwrites the PCLBase::setInputCloud method) More...
virtual void | processInputData ()
Public Member Functions inherited from pcl::QuantizableModality
| QuantizableModality ()
| Constructor. More...
virtual | ~QuantizableModality ()
| Destructor. More...
virtual void | extractAllFeatures (const MaskMap &mask, size_t nr_features, size_t modality_index, std::vector< QuantizedMultiModFeature > &features) const =0
| Extracts all possible features from the modality within the specified mask. More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | quantizeColors ()
void | filterQuantizedColors ()
void | computeDistanceMap (const MaskMap &input, DistanceMap &output) const
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Static Protected Member Functions

static int | quantizeColorOnRGBExtrema (const float r, const float g, const float b)

## Additional Inherited Members

Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT>
class pcl::ColorModality< PointInT >

Definition at line 56 of file color_modality.h.

## Member Typedef Documentation

## PointCloudIn

template<typename PointInT >

typedef pcl::PointCloud<PointInT> pcl::ColorModality< PointInT >::PointCloudIn

Definition at line 79 of file color_modality.h.

## Constructor & Destructor Documentation

## ColorModality()

template<typename PointInT >

pcl::ColorModality< PointInT >::ColorModality | ( |  | ) |

Definition at line 142 of file color_modality.h.

## ~ColorModality()

template<typename PointInT >

pcl::ColorModality< PointInT >::~ColorModality | ( |  | ) |

virtual

Definition at line 149 of file color_modality.h.

## Member Function Documentation

## computeDistanceMap()

template<typename PointInT >

void pcl::ColorModality< PointInT >::computeDistanceMap | ( | const MaskMap & | input,
|  | DistanceMap & | output
| ) |  | const

protected

Definition at line 486 of file color_modality.h.

References pcl::MaskMap::getData(), pcl::DistanceMap::getData(), pcl::MaskMap::getHeight(), pcl::MaskMap::getWidth(), and pcl::DistanceMap::resize().

Referenced by pcl::ColorModality< PointInT >::extractFeatures(), and pcl::ColorModality< PointInT >::setInputCloud().

## extractFeatures()

template<typename PointInT >

void pcl::ColorModality< PointInT >::extractFeatures | ( | const MaskMap & | mask,
|  | size_t | nr_features,
|  | size_t | modality_index,
|  | std::vector< QuantizedMultiModFeature > & | features
| ) |  | const

virtual

Extracts features from this modality within the specified mask.

Parameters

  [in] | mask | defines the areas where features are searched in.
  [in] | nr_features | defines the number of features to be extracted (might be less if not sufficient information is present in the modality).
  [in] | modality_index | the index which is stored in the extracted features.
  [out] | features | the destination for the extracted features.

Implements pcl::QuantizableModality.

Definition at line 173 of file color_modality.h.

References pcl::ColorModality< PointInT >::Candidate::bin_index, pcl::ColorModality< PointInT >::computeDistanceMap(), pcl::geometry::distance(), pcl::ColorModality< PointInT >::Candidate::distance, pcl::MaskMap::getHeight(), pcl::MaskMap::getWidth(), pcl::QuantizedMultiModFeature::modality_index, pcl::QuantizedMultiModFeature::quantized_value, pcl::QuantizedMultiModFeature::x, pcl::ColorModality< PointInT >::Candidate::x, pcl::QuantizedMultiModFeature::y, and pcl::ColorModality< PointInT >::Candidate::y.

Referenced by pcl::ColorModality< PointInT >::getSpreadedQuantizedMap().

## filterQuantizedColors()

template<typename PointInT >

void pcl::ColorModality< PointInT >::filterQuantizedColors | ( |  | ) |

protected

Definition at line 359 of file color_modality.h.

References pcl::QuantizedMap::getData(), pcl::PCLBase< PointInT >::input_, and pcl::QuantizedMap::resize().

Referenced by pcl::ColorModality< PointInT >::processInputData(), and pcl::ColorModality< PointInT >::setInputCloud().

## getQuantizedMap()

template<typename PointInT >

QuantizedMap& pcl::ColorModality< PointInT >::getQuantizedMap | ( |  | ) |

inline virtual

Returns a reference to the internally computed quantized map.

Implements pcl::QuantizableModality.

Definition at line 86 of file color_modality.h.

## getSpreadedQuantizedMap()

template<typename PointInT >

QuantizedMap& pcl::ColorModality< PointInT >::getSpreadedQuantizedMap | ( |  | ) |

inline virtual

Returns a reference to the internally computed spreaded quantized map.

Implements pcl::QuantizableModality.

Definition at line 92 of file color_modality.h.

References pcl::ColorModality< PointInT >::extractFeatures().

## processInputData()

template<typename PointInT >

void pcl::ColorModality< PointInT >::processInputData | ( |  | ) |

virtual

Definition at line 156 of file color_modality.h.

References pcl::ColorModality< PointInT >::filterQuantizedColors(), pcl::ColorModality< PointInT >::quantizeColors(), and pcl::QuantizedMap::spreadQuantizedMap().

Referenced by pcl::ColorModality< PointInT >::setInputCloud().

## quantizeColorOnRGBExtrema()

template<typename PointInT >

int pcl::ColorModality< PointInT >::quantizeColorOnRGBExtrema | ( | const float | r,
|  | const float | g,
|  | const float | b
| ) |  |

inline static protected

Definition at line 434 of file color_modality.h.

Referenced by pcl::ColorModality< PointInT >::quantizeColors(), and pcl::ColorModality< PointInT >::setInputCloud().

## quantizeColors()

template<typename PointInT >

void pcl::ColorModality< PointInT >::quantizeColors | ( |  | ) |

protected

Definition at line 336 of file color_modality.h.

References pcl::PCLBase< PointInT >::input_, pcl::ColorModality< PointInT >::quantizeColorOnRGBExtrema(), and pcl::QuantizedMap::resize().

Referenced by pcl::ColorModality< PointInT >::processInputData(), and pcl::ColorModality< PointInT >::setInputCloud().

## setInputCloud()

template<typename PointInT >

virtual void pcl::ColorModality< PointInT >::setInputCloud | ( | const typename PointCloudIn::ConstPtr & | cloud | ) |

inline virtual

Provide a pointer to the input dataset (overwrites the PCLBase::setInputCloud method)

Parameters

  cloud | the const boost shared pointer to a PointCloud message

Definition at line 105 of file color_modality.h.

References pcl::ColorModality< PointInT >::computeDistanceMap(), pcl::ColorModality< PointInT >::filterQuantizedColors(), pcl::PCLBase< PointInT >::input_, pcl::ColorModality< PointInT >::processInputData(), pcl::ColorModality< PointInT >::quantizeColorOnRGBExtrema(), and pcl::ColorModality< PointInT >::quantizeColors().

The documentation for this class was generated from the following file:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/recognition/include/pcl/recognition/color_modality.h